** This file is part of aITALC
** Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
**------------------------------------------------------------- 

** Here we will try to put a bit of order in the mess of the 
** automatic internal momenta definition.

** The internal lines are assigned an index `i' that in general is
** not the one would like to have in order to attacht to the
** naming convention in the loop integrals.

** With this routine, we declare a new value ilabel, that will
** eventually relabel the internal lines in a (anti)clockwise and
** successively fashion inside the loop. Internal lines outside
** the loop will be given the higher indices.


** ALgorithm
** 1) When closing the loop, report LOOPTYPE`' == {,a,b,c,d,e,u(nknown)}
** 2) Scan internal lines: When one is found belonging to an internal loop, #define ilabel(iline) "1",
** 3) Then keep on scanning adyacent lines (if 1st line was 2<->3, then go from 3<->whatever and so one)
** 4) Label internal-nonloop lines with increasing numbers,
** 5) Twoloops is a mess, by the moment is not considered. 
** You can close the circuit letting lines outside, try to follow all circuits when found a parallel 
** option after closing each loop.
\-

*\message(\(--------Processing diagram no )\currentdiagramnumber())

\if "\import(levelname)" eq "tree" then
  \export(looptype,NONE)
  \export(looptypenumber,0)
\elif "\import(levelname)" eq "loop" then

** The hard stuff

** Reset the given labels
\let(_elabelsgiven,0)
\let(_ilabelsgiven,0)
\let(_looptypenumber,0)
** Stablishing the belonging-to-loop property for each internal line
\Begin(foreach,i,1,\numberofinternallines())
  \let(_i,\i())
  \let(_myloopmomentum,q)
  \let(_belonging,\momentum(\i(),\get(_myloopmomentum)))
  \let(_momentum,\momentum(\i(),))
*  \message(\(The line )\i() \(has the _belonging=)\get(_belonging))
  \if "\get(_belonging)" eq "+\get(_myloopmomentum)" then
     \let(_loopline\get(_i),1)
     \if "\get(_momentum)" eq "+\get(_myloopmomentum)" then
       \let(_inaked,\get(_i))
     \endif
     \inc(_looptypenumber,1)
  \elif "\get(_belonging)" eq "-\get(_myloopmomentum)" then
     \let(_loopline\get(_i),1)
     \if "\get(_momentum)" eq "-\get(_myloopmomentum)" then
       \let(_inaked,\get(_i))
     \endif
     \inc(_looptypenumber,1)
  \else
     \let(_loopline\get(_i),0)
  \endif
*  \message(\(The line )\i() \(has the _loopline)\get(_i)\( = )\get(_loopline\get(_i)))
\End(foreach)

** Exporting looptypenumber
\if   "\get(_looptypenumber)" eq "0" then
  \export(looptype,none)
\elif "\get(_looptypenumber)" eq "1" then
  \export(looptype,a)
\elif "\get(_looptypenumber)" eq "2" then
  \export(looptype,b)
\elif "\get(_looptypenumber)" eq "3" then
  \export(looptype,c)
\elif "\get(_looptypenumber)" eq "4" then
  \export(looptype,d)
\elif "\get(_looptypenumber)" eq "5" then
  \export(looptype,e)
\elif "\get(_looptypenumber)" eq "6" then
  \export(looptype,f)
\else
  \export(looptype,HIGHER)
\endif
\export(looptypenumber,\get(_looptypenumber))


\elif "\import(levelname)" eq "twoloops" then
** Do trivial relabeling, I have no better idea
  \export(looptype,HIGHER)
  \export(looptypenumber,EMPTY)
\else
** Don't ask me for three loops or more!!
\endif 

\+






** $Id: analyze_looptype.prg,v 1.1 2004/10/29 14:07:52 alorca Exp $
