# fortran/bin/fba_script.sh
# This file is part of aITALC
# Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>

#!/bin/bash

filename="$1"
outfilename="$1.eps"
labelprocess="$2"

echo "\
set output \"$outfilename\"
set terminal postscript eps enhanced color solid 20
set size 0.75,1;
#set size square;
set title '{/Times=24 F-B Asymmetry}'
set ylabel '{/Times=20 A_{FB}}'
set xlabel '{/Times=20 {/Symbol \326}s (GeV)}'
set label \'$2\'
#set xrange [6:1000]
set yrange [-1:1]
set mytics 5
set mxtics 5
set format y \"%2.1f\"
show mytics
set linestyle 1 lt 1 lw 4 pt 1 ps 1
set linestyle 2 lt 2 lw 2 pt 1 ps 1
set linestyle 3 lt 3 lw 2 pt 1 ps 1
set linestyle 4 lt 4 lw 2 pt 1 ps 1
set linestyle 5 lt 5 lw 2 pt 1 ps 1
plot    \"$filename\" using 1:3 t \"Born\" with lines 1,\\
        \"$filename\" using 1:6 t \"B+corr\" with lines 4,\\
        \"$filename\" using 1:7 t \"loop^2\" with lines 5
exit
"\
 | gnuplot - 1>/dev/null

#$Id: fba_script.sh,v 1.2 2004/10/07 15:05:08 alorca Exp $
