C Actives the calculation of renormalization parameters for EWSM.model
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C
      subroutine renormalization(active)
      implicit none
      logical active
      integer i1,i2
      double precision MLN(3),MLL(3),MQU(3),MQD(3)
      double precision MLN2(3),MLL2(3),MQU2(3),MQD2(3)
      double precision GVLN,GVLN2,GVLL,GVLL2,GVQU,GVQU2,GVQD,GVQD2
      double precision GALN,GALN2,GALL,GALL2,GAQU,GAQU2,GAQD,GAQD2
      double precision QLN,QLL,QQU,QQD
      double precision QLN2,QLL2,QQU2,QQD2
      double complex  SelfWT, SelfAAT, SelfAZT, SelfZAT, SelfZZT
      double complex DSelfWT,DSelfAAT,DSelfAZT,DSelfZAT,DSelfZZT
      double complex  SelfH, SelfGW, SelfG0
      double complex DSelfH,DSelfGW,DSelfG0
      double complex Tadpole
      
      double precision alpha,cw2,sw2

#include <variablelist.hf>
#include <looptools.h>
*#define DEBUG 1
C -----------------------------------------------------------------------
C At the very beginning we allow to set to zero all renormalization
C parameters and fields
      if (active) goto 10
      
      dMMW=zero
      dMMZ=zero
      dMMH=zero
      dMMGW=zero
      dMMG0=zero
      
      dZAA=zero
      dZAZ=zero
      dZZZ=zero
      dZH=zero
      dZW=zero
      dZGW=zero 
      dZG0=zero
      dsw=zero
      dtad=zero
      dZe=zero
      
      do i1=1,3
        do i2=1,4
          dMf(i2,i1)=zero
          dZfV(i2,i1)=zero
          dZfA(i2,i1)=zero
        enddo
      enddo

      goto 20
C -----------------------------------------------------------------------
 10   continue

      MLN(1)=Mne
      MLN(2)=Mnm
      MLN(3)=Mnt
      MLL(1)=Mle
      MLL(2)=Mlm
      MLL(3)=Mlt
      MQU(1)=Mu
      MQU(2)=Mc
      MQU(3)=Mt
      MQD(1)=Md
      MQD(2)=Ms
      MQD(3)=Mb

      do i1=1,3
        MLN2(i1)=MLN(i1)**2
        MLL2(i1)=MLL(i1)**2
        MQU2(i1)=MQU(i1)**2
        MQD2(i1)=MQD(i1)**2
      enddo

      QLN=Qne
      QLN2=QLN**2
      GALN=GAne
      GALN2=GAne**2
      GVLN=GVne
      GVLN2=GVne**2

      QLL=Qle
      QLL2=QLL**2
      GALL=GAle
      GALL2=GAle**2
      GVLL=GVle
      GVLL2=GVle**2

      QQU=Qu
      QQU2=QQU**2
      GAQU=GAu
      GAQU2=GAu**2
      GVQU=GVu
      GVQU2=GVu**2

      QQD=Qd
      QQD2=QQD**2
      GAQD=GAd
      GAQD2=GAd**2
      GVQD=GVd
      GVQD2=GVd**2

      do i1=1,3


        dMf(1,i1) = + MLN(i1)*(e/8/Pi)**2 * DBLE(
     &         - 1/sw**2
     &         - MLN2(i1)*B1(MLN2(i1),MLN2(i1),MMZ)/(MW*sw)**2
     &         - MLN2(i1)*B1(MLN2(i1),MLN2(i1),MMH)/(MW*sw)**2
     &         - MLN2(i1)*B1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2
     &         - MLN2(i1)*B0(MLN2(i1),MLN2(i1),MMZ)/(MW*sw)**2
     &         + MLN2(i1)*B0(MLN2(i1),MLN2(i1),MMH)/(MW*sw)**2
     &         - MLL2(i1)*B1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2
     &         - 2*MLL2(i1)*B0(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2
     &         + 4*GVLN2
     &         - 8*GVLN2*B1(MLN2(i1),MLN2(i1),MMZ)
     &         - 16*GVLN2*B0(MLN2(i1),MLN2(i1),MMZ)
     &         - 12*GALN2
     &         - 8*GALN2*B1(MLN2(i1),MLN2(i1),MMZ)
     &         + 16*GALN2*B0(MLN2(i1),MLN2(i1),MMZ)
     &         - 2*B1(MLN2(i1),MLL2(i1),MMW)/sw**2
     &         )

        dMf(2,i1) = + MLL(i1)*(e/8/Pi)**2 * DBLE(
     &         - 1/sw**2
     &         - MLL2(i1)*B1(MLL2(i1),MLL2(i1),MMZ)/(MW*sw)**2
     &         - MLL2(i1)*B1(MLL2(i1),MLL2(i1),MMH)/(MW*sw)**2
     &         - MLL2(i1)*B1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2
     &         - MLL2(i1)*B0(MLL2(i1),MLL2(i1),MMZ)/(MW*sw)**2
     &         + MLL2(i1)*B0(MLL2(i1),MLL2(i1),MMH)/(MW*sw)**2
     &         - MLN2(i1)*B1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2
     &         - 2*MLN2(i1)*B0(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2
     &         + 4*QLL2
     &         - 8*QLL2*B1(MLL2(i1),MLL2(i1),MMA)
     &         - 16*QLL2*B0(MLL2(i1),MLL2(i1),MMA)
     &         + 4*GVLL2
     &         - 8*GVLL2*B1(MLL2(i1),MLL2(i1),MMZ)
     &         - 16*GVLL2*B0(MLL2(i1),MLL2(i1),MMZ)
     &         - 12*GALL2
     &         - 8*GALL2*B1(MLL2(i1),MLL2(i1),MMZ)
     &         + 16*GALL2*B0(MLL2(i1),MLL2(i1),MMZ)
     &         - 2*B1(MLL2(i1),MLN2(i1),MMW)/sw**2
     &         )
      
        dMf(3,i1) = + MQU(i1)*(e/8/Pi)**2 * DBLE(
     &         - 1/sw**2
     &         - MQU2(i1)*B1(MQU2(i1),MQU2(i1),MMZ)/(MW*sw)**2
     &         - MQU2(i1)*B1(MQU2(i1),MQU2(i1),MMH)/(MW*sw)**2
     &         - MQU2(i1)*B1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2
     &         - MQU2(i1)*B0(MQU2(i1),MQU2(i1),MMZ)/(MW*sw)**2
     &         + MQU2(i1)*B0(MQU2(i1),MQU2(i1),MMH)/(MW*sw)**2
     &         - MQD2(i1)*B1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2
     &         - 2*MQD2(i1)*B0(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2
     &         + 4*QQU2
     &         - 8*QQU2*B1(MQU2(i1),MQU2(i1),MMA)
     &         - 16*QQU2*B0(MQU2(i1),MQU2(i1),MMA)
     &         + 4*GVQU2
     &         - 8*GVQU2*B1(MQU2(i1),MQU2(i1),MMZ)
     &         - 16*GVQU2*B0(MQU2(i1),MQU2(i1),MMZ)
     &         - 12*GAQU2
     &         - 8*GAQU2*B1(MQU2(i1),MQU2(i1),MMZ)
     &         + 16*GAQU2*B0(MQU2(i1),MQU2(i1),MMZ)
     &         - 2*B1(MQU2(i1),MQD2(i1),MMW)/sw**2
     &         )
      
        dMf(4,i1) = + MQD(i1)*(e/8/Pi)**2 * DBLE(
     &         - 1/sw**2
     &         - MQD2(i1)*B1(MQD2(i1),MQD2(i1),MMZ)/(MW*sw)**2
     &         - MQD2(i1)*B1(MQD2(i1),MQD2(i1),MMH)/(MW*sw)**2
     &         - MQD2(i1)*B1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2
     &         - MQD2(i1)*B0(MQD2(i1),MQD2(i1),MMZ)/(MW*sw)**2
     &         + MQD2(i1)*B0(MQD2(i1),MQD2(i1),MMH)/(MW*sw)**2
     &         - MQU2(i1)*B1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2
     &         - 2*MQU2(i1)*B0(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2
     &         + 4*QQD2
     &         - 8*QQD2*B1(MQD2(i1),MQD2(i1),MMA)
     &         - 16*QQD2*B0(MQD2(i1),MQD2(i1),MMA)
     &         + 4*GVQD2
     &         - 8*GVQD2*B1(MQD2(i1),MQD2(i1),MMZ)
     &         - 16*GVQD2*B0(MQD2(i1),MQD2(i1),MMZ)
     &         - 12*GAQD2
     &         - 8*GAQD2*B1(MQD2(i1),MQD2(i1),MMZ)
     &         + 16*GAQD2*B0(MQD2(i1),MQD2(i1),MMZ)
     &         - 2*B1(MQD2(i1),MQU2(i1),MMW)/sw**2
     &         )
      
      
C For type N neutrinos
        dZfV(1,i1) = + (e/8/Pi)**2* DBLE (
     &         + MLN2(i1) * (
     &         + B1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2
     &         + B1(MLN2(i1),MLN2(i1),MMZ)/(MW*sw)**2
     &         + B1(MLN2(i1),MLN2(i1),MMH)/(MW*sw)**2
     &         + 2*DB1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2*MLL2(i1)
     &         + 4*DB1(MLN2(i1),MLL2(i1),MMW)/sw**2
     &         + 16*DB1(MLN2(i1),MLN2(i1),MMZ)*GALN2
     &         + 16*DB1(MLN2(i1),MLN2(i1),MMZ)*GVLN2
     &         + 4*DB0(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2*MLL2(i1)
     &         - 32*DB0(MLN2(i1),MLN2(i1),MMZ)*GALN2
     &         + 32*DB0(MLN2(i1),MLN2(i1),MMZ)*GVLN2
     &         )
     &         + MLN2(i1)**2 * (
     &         + 2*DB1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2
     &         + 2*DB1(MLN2(i1),MLN2(i1),MMZ)/(MW*sw)**2
     &         + 2*DB1(MLN2(i1),MLN2(i1),MMH)/(MW*sw)**2
     &         + 2*DB0(MLN2(i1),MLN2(i1),MMZ)/(MW*sw)**2
     &         - 2*DB0(MLN2(i1),MLN2(i1),MMH)/(MW*sw)**2
     &         )
     &         + 1/sw**2
     &         + 4*QLN2
     &         + 4*GALN2
     &         + 4*GVLN2
     &         + B1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2*MLL2(i1)
     &         + 2*B1(MLN2(i1),MLL2(i1),MMW)/sw**2
     &         + 8*B1(MLN2(i1),MLN2(i1),MMZ)*GALN2
     &         + 8*B1(MLN2(i1),MLN2(i1),MMZ)*GVLN2
     &         )
      
        dZfA(1,i1) = + (e/8/Pi)**2* DBLE(
     &         - MLN2(i1)*B1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2
     &         + 1/sw**2
     &         + 8*GALN*GVLN
     &         + B1(MLN2(i1),MLL2(i1),MMW)/(MW*sw)**2*MLL2(i1)
     &         + 2*B1(MLN2(i1),MLL2(i1),MMW)/sw**2
     &         + 16*B1(MLN2(i1),MLN2(i1),MMZ)*GALN*GVLN
     &       )
      
C For Lepton type electron
        dZfV(2,i1) = + (e/8/Pi)**2* DBLE (
     &         + MLL2(i1) * (
     &         + B1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2
     &         + B1(MLL2(i1),MLL2(i1),MMZ)/(MW*sw)**2
     &         + B1(MLL2(i1),MLL2(i1),MMH)/(MW*sw)**2
     &         + 2*DB1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2*MLN2(i1)
     &         + 4*DB1(MLL2(i1),MLN2(i1),MMW)/sw**2
     &         + 16*DB1(MLL2(i1),MLL2(i1),MMA)*QLL2
     &         + 16*DB1(MLL2(i1),MLL2(i1),MMZ)*GALL2
     &         + 16*DB1(MLL2(i1),MLL2(i1),MMZ)*GVLL2
     &         + 4*DB0(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2*MLN2(i1)
     &         + 32*DB0(MLL2(i1),MLL2(i1),MMA)*QLL2
     &         - 32*DB0(MLL2(i1),MLL2(i1),MMZ)*GALL2
     &         + 32*DB0(MLL2(i1),MLL2(i1),MMZ)*GVLL2
     &         )
     &         + MLL2(i1)**2 * (
     &         + 2*DB1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2
     &         + 2*DB1(MLL2(i1),MLL2(i1),MMZ)/(MW*sw)**2
     &         + 2*DB1(MLL2(i1),MLL2(i1),MMH)/(MW*sw)**2
     &         + 2*DB0(MLL2(i1),MLL2(i1),MMZ)/(MW*sw)**2
     &         - 2*DB0(MLL2(i1),MLL2(i1),MMH)/(MW*sw)**2
     &         )
     &         + 1/sw**2
     &         + 4*QLL2
     &         + 4*GALL2
     &         + 4*GVLL2
     &         + B1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2*MLN2(i1)
     &         + 2*B1(MLL2(i1),MLN2(i1),MMW)/sw**2
     &         + 8*B1(MLL2(i1),MLL2(i1),MMA)*QLL2
     &         + 8*B1(MLL2(i1),MLL2(i1),MMZ)*GALL2
     &         + 8*B1(MLL2(i1),MLL2(i1),MMZ)*GVLL2
     &         )
      
        dZfA(2,i1) = + (e/8/Pi)**2* DBLE(
     &         - MLL2(i1)*B1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2
     &         + 1/sw**2
     &         + 8*GALL*GVLL
     &         + B1(MLL2(i1),MLN2(i1),MMW)/(MW*sw)**2*MLN2(i1)
     &         + 2*B1(MLL2(i1),MLN2(i1),MMW)/sw**2
     &         + 16*B1(MLL2(i1),MLL2(i1),MMZ)*GALL*GVLL
     &         )
      
C For type Up Quarks
        dZfV(3,i1) = + (e/8/Pi)**2* DBLE (
     &         + MQU2(i1) * (
     &         + B1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2
     &         + B1(MQU2(i1),MQU2(i1),MMZ)/(MW*sw)**2
     &         + B1(MQU2(i1),MQU2(i1),MMH)/(MW*sw)**2
     &         + 2*DB1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2*MQD2(i1)
     &         + 4*DB1(MQU2(i1),MQD2(i1),MMW)/sw**2
     &         + 16*DB1(MQU2(i1),MQU2(i1),MMA)*QQU2
     &         + 16*DB1(MQU2(i1),MQU2(i1),MMZ)*GAQU2
     &         + 16*DB1(MQU2(i1),MQU2(i1),MMZ)*GVQU2
     &         + 4*DB0(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2*MQD2(i1)
     &         + 32*DB0(MQU2(i1),MQU2(i1),MMA)*QQU2
     &         - 32*DB0(MQU2(i1),MQU2(i1),MMZ)*GAQU2
     &         + 32*DB0(MQU2(i1),MQU2(i1),MMZ)*GVQU2
     &         )
     &         + MQU2(i1)**2 * (
     &         + 2*DB1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2
     &         + 2*DB1(MQU2(i1),MQU2(i1),MMZ)/(MW*sw)**2
     &         + 2*DB1(MQU2(i1),MQU2(i1),MMH)/(MW*sw)**2
     &         + 2*DB0(MQU2(i1),MQU2(i1),MMZ)/(MW*sw)**2
     &         - 2*DB0(MQU2(i1),MQU2(i1),MMH)/(MW*sw)**2
     &         )
     &         + 1/sw**2
     &         + 4*QQU2
     &         + 4*GAQU2
     &         + 4*GVQU2
     &         + B1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2*MQD2(i1)
     &         + 2*B1(MQU2(i1),MQD2(i1),MMW)/sw**2
     &         + 8*B1(MQU2(i1),MQU2(i1),MMA)*QQU2
     &         + 8*B1(MQU2(i1),MQU2(i1),MMZ)*GAQU2
     &         + 8*B1(MQU2(i1),MQU2(i1),MMZ)*GVQU2
     &         )
      
        dZfA(3,i1) = + (e/8/Pi)**2* DBLE(
     &         - MQU2(i1)*B1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2
     &         + 1/sw**2
     &         + 8*GAQU*GVQU
     &         + B1(MQU2(i1),MQD2(i1),MMW)/(MW*sw)**2*MQD2(i1)
     &         + 2*B1(MQU2(i1),MQD2(i1),MMW)/sw**2
     &         + 16*B1(MQU2(i1),MQU2(i1),MMZ)*GAQU*GVQU
     &         )
C For Down type Quarks
        dZfV(4,i1) = + (e/8/Pi)**2* DBLE (
     &         + MQD2(i1) * (
     &         + B1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2
     &         + B1(MQD2(i1),MQD2(i1),MMZ)/(MW*sw)**2
     &         + B1(MQD2(i1),MQD2(i1),MMH)/(MW*sw)**2
     &         + 2*DB1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2*MQU2(i1)
     &         + 4*DB1(MQD2(i1),MQU2(i1),MMW)/sw**2
     &         + 16*DB1(MQD2(i1),MQD2(i1),MMA)*QQD2
     &         + 16*DB1(MQD2(i1),MQD2(i1),MMZ)*GAQD2
     &         + 16*DB1(MQD2(i1),MQD2(i1),MMZ)*GVQD2
     &         + 4*DB0(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2*MQU2(i1)
     &         + 32*DB0(MQD2(i1),MQD2(i1),MMA)*QQD2
     &         - 32*DB0(MQD2(i1),MQD2(i1),MMZ)*GAQD2
     &         + 32*DB0(MQD2(i1),MQD2(i1),MMZ)*GVQD2
     &         )
     &         + MQD2(i1)**2 * (
     &         + 2*DB1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2
     &         + 2*DB1(MQD2(i1),MQD2(i1),MMZ)/(MW*sw)**2
     &         + 2*DB1(MQD2(i1),MQD2(i1),MMH)/(MW*sw)**2
     &         + 2*DB0(MQD2(i1),MQD2(i1),MMZ)/(MW*sw)**2
     &         - 2*DB0(MQD2(i1),MQD2(i1),MMH)/(MW*sw)**2
     &         )
     &         + 1/sw**2
     &         + 4*QQD2
     &         + 4*GAQD2
     &         + 4*GVQD2
     &         + B1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2*MQU2(i1)
     &         + 2*B1(MQD2(i1),MQU2(i1),MMW)/sw**2
     &         + 8*B1(MQD2(i1),MQD2(i1),MMA)*QQD2
     &         + 8*B1(MQD2(i1),MQD2(i1),MMZ)*GAQD2
     &         + 8*B1(MQD2(i1),MQD2(i1),MMZ)*GVQD2
     &         )
        
        dZfA(4,i1) = + (e/8/Pi)**2* DBLE(
     &       - MQD2(i1)*B1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2
     &       + 1/sw**2
     &       + 8*GAQD*GVQD
     &       + B1(MQD2(i1),MQU2(i1),MMW)/(MW*sw)**2*MQU2(i1)
     &       + 2*B1(MQD2(i1),MQU2(i1),MMW)/sw**2
     &       + 16*B1(MQD2(i1),MQD2(i1),MMZ)*GAQD*GVQD
     &       )

      enddo

C End of fermion mass and field renormalization
C -----------------------------------------------------------------------
      SelfWT = + (e**2*Pi**(-2)/576)*sw**(-2)*cw**2 * (
     &     + 16*MW**2
     &     - 48*MZ**2
     &     - 84*A0(MMW)
     &     + 24*A0(MMW)*MW**(-2)*MZ**2
     &     + 72*A0(MMZ)
     &     - 24*A0(MMZ)*MW**(-2)*MZ**2
     &     + 24*B0(MMW,MMW,MMZ)*MW**(-2)*MZ**4
     &     - 180*B0(MMW,MMW,MMZ)*MW**2
     &     - 132*B0(MMW,MMW,MMZ)*MZ**2
     &     )
      SelfWT = SelfWT + (e**2*Pi**(-2)/576)*sw**(-2)  * (
     &     - 92*MW**2
     &     - 6*MZ**2
     &     - 6*MH**2
     &     + 114*A0(MMW)
     &     + 3*A0(MMW)*MW**(-2)*MZ**2
     &     + 3*A0(MMW)*MW**(-2)*MH**2
     &     + 9*A0(MMZ)
     &     - 3*A0(MMZ)*MW**(-2)*MZ**2
     &     + 9*A0(MMH)
     &     - 3*A0(MMH)*MW**(-2)*MH**2
     &     + 3*B0(MMW,MMW,MMZ)*MW**(-2)*MZ**4
     &     - 12*B0(MMW,MMW,MMZ)*MZ**2
     &     + 3*B0(MMW,MMW,MMH)*MW**(-2)*MH**4
     &     + 36*B0(MMW,MMW,MMH)*MW**2
     &     - 12*B0(MMW,MMW,MMH)*MH**2
     &     )
      SelfWT = SelfWT + (e**2*Pi**(-2)/576)*sw**2*
     & cw**(-2) * (
     &     + 36*B0(MMW,MMW,MMZ)*MW**2
     &     )
      SelfWT = SelfWT + (e**2*Pi**(-2)/576) * (
     &     - 48*MA**2
     &     + 16*MW**2
     &     + 72*A0(MMA)
     &     - 24*A0(MMA)*MA**2*MW**(-2)
     &     - 84*A0(MMW)
     &     + 24*A0(MMW)*MA**2*MW**(-2)
     &     - 132*B0(MMW,MMA,MMW)*MA**2
     &     + 24*B0(MMW,MMA,MMW)*MA**4*MW**(-2)
     &     - 144*B0(MMW,MMA,MMW)*MW**2
     &     )
      do i1=1,3
        SelfWT = SelfWT + (e**2*Pi**(-2)/576)*sw**(-2)  * (
     &       - 12*A0(MLN2(i1))
     &       + 6*A0(MLN2(i1))*MLN2(i1)*MW**(-2)
     &       - 6*A0(MLN2(i1))*MLL2(i1)*MW**(-2)
     &       - 12*A0(MLL2(i1))
     &       - 6*A0(MLL2(i1))*MLN2(i1)*MW**(-2)
     &       + 6*A0(MLL2(i1))*MLL2(i1)*MW**(-2)
     &       + 12*B0(MMW,MLL2(i1),MLN2(i1))*MW**2
     &       - 6*B0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)
     &       - 6*B0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)**2*MW**(-2)
     &       + 12*B0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)*MLL2(i1)*MW**(-2)
     &       - 6*B0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)
     &       - 6*B0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)**2*MW**(-2)
     &       + 12*MLN2(i1)
     &       + 12*MLL2(i1)
     &     )
        do i2=1,3
          SelfWT = SelfWT + CKM(i1,i2)*CKMD(i1,i2)
     &         *(e**2*Pi**(-2)/576)*sw**(-2) * (
     &         - 12*MW**2
     &         - 36*A0(MQU2(i1))
     &         + 18*A0(MQU2(i1))*MQU2(i1)*MW**(-2)
     &         - 18*A0(MQU2(i1))*MQD2(i2)*MW**(-2)
     &         - 36*A0(MQD2(i2))
     &         - 18*A0(MQD2(i2))*MQU2(i1)*MW**(-2)
     &         + 18*A0(MQD2(i2))*MQD2(i2)*MW**(-2)
     &         + 36*B0(MMW,MQU2(i1),MQD2(i2))*MW**2
     &         - 18*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)
     &         - 18*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)**2*MW**(-2)
     &         + 36*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)*MQD2(i2)*MW**(-2)
     &         - 18*B0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)
     &         - 18*B0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)**2*MW**(-2)
     &         + 36*MQU2(i1)
     &         + 36*MQD2(i2)
     &         )
        enddo
      enddo
      
      DSelfWT = + (e**2*Pi**(-2)/576)*sw**(-2)*cw**2 * (
     &     - 8
     &     - 24*A0(MMW)*MW**(-4)*MZ**2
     &     + 24*A0(MMW)*MW**(-2)
     &     + 24*A0(MMZ)*MW**(-4)*MZ**2
     &     - 24*A0(MMZ)*MW**(-2)
     &     - 144*B0(MMW,MMW,MMZ)
     &     - 24*B0(MMW,MMW,MMZ)*MW**(-4)*MZ**4
     &     + 48*B0(MMW,MMW,MMZ)*MW**(-2)*MZ**2
     &     + 24*DB0(MMW,MMW,MMZ)*MW**(-2)*MZ**4
     &     - 180*DB0(MMW,MMW,MMZ)*MW**2
     &     - 132*DB0(MMW,MMW,MMZ)*MZ**2
     &     )
      DSelfWT = DSelfWT + (e**2*Pi**(-2)/576)*sw**(-2) * (
     &     - 8
     &     - 3*A0(MMW)*MW**(-4)*MZ**2
     &     - 3*A0(MMW)*MW**(-4)*MH**2
     &     + 6*A0(MMW)*MW**(-2)
     &     + 3*A0(MMZ)*MW**(-4)*MZ**2
     &     - 3*A0(MMZ)*MW**(-2)
     &     + 3*A0(MMH)*MW**(-4)*MH**2
     &     - 3*A0(MMH)*MW**(-2)
     &     - 3*B0(MMW,MMW,MMZ)*MW**(-4)*MZ**4
     &     + 6*B0(MMW,MMW,MMZ)*MW**(-2)*MZ**2
     &     - 3*B0(MMW,MMW,MMH)*MW**(-4)*MH**4
     &     + 6*B0(MMW,MMW,MMH)*MW**(-2)*MH**2
     &     + 3*DB0(MMW,MMW,MMZ)*MW**(-2)*MZ**4
     &     - 12*DB0(MMW,MMW,MMZ)*MZ**2
     &     + 3*DB0(MMW,MMW,MMH)*MW**(-2)*MH**4
     &     + 36*DB0(MMW,MMW,MMH)*MW**2
     &     - 12*DB0(MMW,MMW,MMH)*MH**2
     &     )
      DSelfWT = DSelfWT + (e**2*Pi**(-2)/576)*sw**2*cw**(-2) * (
     &     + 36*DB0(MMW,MMW,MMZ)*MW**2
     &     )
      DSelfWT = DSelfWT + (e**2*Pi**(-2)/576) * (
     &     - 8
     &     + 24*A0(MMA)*MA**2*MW**(-4)
     &     - 24*A0(MMA)*MW**(-2)
     &     - 24*A0(MMW)*MA**2*MW**(-4)
     &     + 24*A0(MMW)*MW**(-2)
     &     - 144*B0(MMW,MMA,MMW)
     &     + 48*B0(MMW,MMA,MMW)*MA**2*MW**(-2)
     &     - 24*B0(MMW,MMA,MMW)*MA**4*MW**(-4)
     &     - 132*DB0(MMW,MMA,MMW)*MA**2
     &     + 24*DB0(MMW,MMA,MMW)*MA**4*MW**(-2)
     &     - 144*DB0(MMW,MMA,MMW)*MW**2
     &     )
      do i1=1,3
      DSelfWT = DSelfWT + (e**2*Pi**(-2)/576)*sw**(-2) * (
     &     - 6*A0(MLN2(i1))*MLN2(i1)*MW**(-4)
     &     + 6*A0(MLN2(i1))*MLL2(i1)*MW**(-4)
     &     + 6*A0(MLL2(i1))*MLN2(i1)*MW**(-4)
     &     - 6*A0(MLL2(i1))*MLL2(i1)*MW**(-4)
     &     +12*B0(MMW,MLL2(i1),MLN2(i1))
     &     + 6*B0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)**2*MW**(-4)
     &     -12*B0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)*MLL2(i1)*MW**(-4)
     &     + 6*B0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)**2*MW**(-4)
     &     +12*DB0(MMW,MLL2(i1),MLN2(i1))*MW**2
     &     - 6*DB0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)
     &     - 6*DB0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)**2*MW**(-2)
     &     +12*DB0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)*MLL2(i1)*MW**(-2)
     &     - 6*DB0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)
     &     - 6*DB0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)**2*MW**(-2)
     &     )
      do i2=1,3
      DSelfWT = DSelfWT + CKM(i1,i2)*CKMD(i1,i2)*(e**2*
     & Pi**(-2)/576)*sw**(-2) * (
     &     - 12
     &     - 18*A0(MQU2(i1))*MQU2(i1)*MW**(-4)
     &     + 18*A0(MQU2(i1))*MQD2(i2)*MW**(-4)
     &     + 18*A0(MQD2(i2))*MQU2(i1)*MW**(-4)
     &     - 18*A0(MQD2(i2))*MQD2(i2)*MW**(-4)
     &     + 36*B0(MMW,MQU2(i1),MQD2(i2))
     &     + 18*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)**2*MW**(-4)
     &     - 36*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)*MQD2(i2)*MW**(-4)
     &     + 18*B0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)**2*MW**(-4)
     &     + 36*DB0(MMW,MQU2(i1),MQD2(i2))*MW**2
     &     - 18*DB0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)
     &     - 18*DB0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)**2*MW**(-2)
     &     + 36*DB0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)*MQD2(i2)*MW**(-2)
     &     - 18*DB0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)
     &     - 18*DB0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)**2*MW**(-2)
     &     )
      enddo
      enddo

      SelfAAT = + (e**2*Pi**(-2)/48) * (
     &     - 12*MW**2
     &     + 12*A0(MMW)
     &     - 12*B0(MMA,MMW,MMW)*MW**2
     &     )

      DSelfAAT = + (e**2*Pi**(-2)/48) * (
     &     - 4*QLL2
     &     - 12*QQU2
     &     - 12*QQD2
     &     - 9*B0(MMA,MMW,MMW)
     &     - 12*DB0(MMA,MMW,MMW)*MW**2
     &     )
      do i1 = 1, 3
        SelfAAT = SelfAAT + (e**2*Pi**(-2)/48) * (
     &       - 8*A0(MLL2(i1))*QLL2
     &       - 24*A0(MQU2(i1))*QQU2
     &       - 24*A0(MQD2(i1))*QQD2
     &       + 8*B0(MMA,MLL2(i1),MLL2(i1))*MLL2(i1)*QLL2
     &       + 24*B0(MMA,MQU2(i1),MQU2(i1))*MQU2(i1)*QQU2
     &       + 24*B0(MMA,MQD2(i1),MQD2(i1))*MQD2(i1)*QQD2
     &       + 8*MLL2(i1)*QLL2
     &       + 24*MQU2(i1)*QQU2
     &       + 24*MQD2(i1)*QQD2
     &       )
        DSelfAAT = DSelfAAT + (e**2*Pi**(-2)/48) * (
     &       + 4*B0(MMA,MLL2(i1),MLL2(i1))*QLL2
     &       + 12*B0(MMA,MQU2(i1),MQU2(i1))*QQU2
     &       + 12*B0(MMA,MQD2(i1),MQD2(i1))*QQD2
     &       + 8*DB0(MMA,MLL2(i1),MLL2(i1))*MLL2(i1)*QLL2
     &       + 24*DB0(MMA,MQU2(i1),MQU2(i1))*MQU2(i1)*QQU2
     &       + 24*DB0(MMA,MQD2(i1),MQD2(i1))*MQD2(i1)*QQD2
     &       )
      enddo

      SelfZAT = + (e**2*Pi**(-2)/24)*sw**(-1)*cw* (
     &     + 5*MW**2
     &     - 5*A0(MMW)
     &     + 8*B0(MMA,MMW,MMW)*MW**2
     &     )
      SelfZAT = SelfZAT + (e**2*Pi**(-2)/24)*sw*cw**(-1) * (
     &     - MW**2
     &     + A0(MMW)
     &     + 2*B0(MMA,MMW,MMW)*MW**2
     &     )

      SelfAZT = + (e**2*Pi**(-2)/288)*sw**(-1)*cw * (
     &     + 60*MW**2
     &     + 2*MZ**2
     &     - 60*A0(MMW)
     &     + 96*B0(MMZ,MMW,MMW)*MW**2
     &     + 57*B0(MMZ,MMW,MMW)*MZ**2
     &     )
      SelfAZT = SelfAZT + (e**2*Pi**(-2)/288)*sw*cw**(-1) * (
     &     - 12*MW**2
     &     + 2*MZ**2
     &     + 12*A0(MMW)
     &     + 24*B0(MMZ,MMW,MMW)*MW**2
     &     + 3*B0(MMZ,MMW,MMW)*MZ**2
     &     )
      SelfAZT = SelfAZT + (e**2*Pi**(-2)/288) * (
     &     + 24*MZ**2*GVLL*QLL
     &     + 72*MZ**2*GVQU*QQU
     &     + 72*MZ**2*GVQD*QQD
     &     )
      do i1 = 1, 3
        SelfZAT = SelfZAT + (e**2*Pi**(-2)/24) * (
     &       + 4*A0(MLL2(i1))*GVLL*QLL
     &       + 12*A0(MQU2(i1))*GVQU*QQU
     &       + 12*A0(MQD2(i1))*GVQD*QQD
     &       - 4*B0(MMA,MLL2(i1),MLL2(i1))*MLL2(i1)*GVLL*QLL
     &       - 12*B0(MMA,MQU2(i1),MQU2(i1))*MQU2(i1)*GVQU*QQU
     &       - 12*B0(MMA,MQD2(i1),MQD2(i1))*MQD2(i1)*GVQD*QQD
     &       - 4*MLL2(i1)*GVLL*QLL
     &       - 12*MQU2(i1)*GVQU*QQU
     &       - 12*MQD2(i1)*GVQD*QQD
     &       )
        SelfAZT = SelfAZT + (e**2*Pi**(-2)/288) * (
     &       + 48*A0(MLL2(i1))*GVLL*QLL
     &       + 144*A0(MQU2(i1))*GVQU*QQU
     &       + 144*A0(MQD2(i1))*GVQD*QQD
     &       - 24*B0(MMZ,MLL2(i1),MLL2(i1))*MZ**2*GVLL*QLL
     &       - 48*B0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*GVLL*QLL
     &       - 72*B0(MMZ,MQU2(i1),MQU2(i1))*MZ**2*GVQU*QQU
     &       - 144*B0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*GVQU*QQU
     &       - 72*B0(MMZ,MQD2(i1),MQD2(i1))*MZ**2*GVQD*QQD
     &       - 144*B0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*GVQD*QQD
     &       - 48*MLL2(i1)*GVLL*QLL
     &       - 144*MQU2(i1)*GVQU*QQU
     &       - 144*MQD2(i1)*GVQD*QQD
     &       )
      enddo



      SelfZZT = + (e**2*Pi**(-2)/576)*
     & sw**(-2)*cw**(-4) * (
     &     + 36*B0(MMZ,MMZ,MMH)*MW**2
     &     )
      SelfZZT = SelfZZT + (e**2*Pi**(-2)/576)*
     & sw**(-2)*cw**(-2) * (
     &     - 4*MZ**2
     &     - 6*MH**2
     &     + 3*A0(MMZ)
     &     + 3*A0(MMZ)*MZ**(-2)*MH**2
     &     + 9*A0(MMH)
     &     - 3*A0(MMH)*MZ**(-2)*MH**2
     &     + 3*B0(MMZ,MMZ,MMH)*MZ**(-2)*MH**4
     &     - 12*B0(MMZ,MMZ,MMH)*MH**2
     &     )
      SelfZZT = SelfZZT + (e**2*Pi**(-2)/576)*
     & sw**(-2)*cw**2 * (
     &     - 108*MW**2
     &     - 6*MZ**2
     &     + 108*A0(MMW)
     &     - 180*B0(MMZ,MMW,MMW)*MW**2
     &     - 117*B0(MMZ,MMW,MMW)*MZ**2
     &     )
      SelfZZT = SelfZZT + (e**2*Pi**(-2)/576)*sw**2*
     & cw**(-2) * (
     &     - 12*MW**2
     &     + 2*MZ**2
     &     + 12*A0(MMW)
     &     + 60*B0(MMZ,MMW,MMW)*MW**2
     &     + 3*B0(MMZ,MMW,MMW)*MZ**2
     &     )
      SelfZZT = SelfZZT + (e**2*Pi**(-2)/576) * (
     &     + 24*MW**2
     &     - 48*MZ**2*GVLN2
     &     - 48*MZ**2*GALN2
     &     - 48*MZ**2*GVLL2
     &     - 48*MZ**2*GALL2
     &     - 144*MZ**2*GVQU2
     &     - 144*MZ**2*GAQU2
     &     - 144*MZ**2*GVQD2
     &     - 144*MZ**2*GAQD2
     &     - 4*MZ**2
     &     - 24*A0(MMW)
     &     + 24*B0(MMZ,MMW,MMW)*MW**2
     &     - 6*B0(MMZ,MMW,MMW)*MZ**2
     &     )

      DSelfZZT = + (e**2*Pi**(-2)/576)*
     & sw**(-2)*cw**(-4) * (
     &     + 36*DB0(MMZ,MMZ,MMH)*MW**2
     &     )
      DSelfZZT = DSelfZZT + (e**2*Pi**(-2)/576)*
     & sw**(-2)*cw**(-2) * (
     &     + 2
     &     - 3*A0(MMZ)*MZ**(-4)*MH**2
     &     + 3*A0(MMZ)*MZ**(-2)
     &     + 3*A0(MMH)*MZ**(-4)*MH**2
     &     - 3*A0(MMH)*MZ**(-2)
     &     - 3*B0(MMZ,MMZ,MMH)*MZ**(-4)*MH**4
     &     + 6*B0(MMZ,MMZ,MMH)*MZ**(-2)*MH**2
     &     + 3*DB0(MMZ,MMZ,MMH)*MZ**(-2)*MH**4
     &     - 12*DB0(MMZ,MMZ,MMH)*MH**2
     &     )
      DSelfZZT = DSelfZZT + (e**2*Pi**(-2)/576)*
     & sw**(-2)*cw**2 * (
     &     - 6
     &     - 117*B0(MMZ,MMW,MMW)
     &     - 180*DB0(MMZ,MMW,MMW)*MW**2
     &     - 117*DB0(MMZ,MMW,MMW)*MZ**2
     &     )
      DSelfZZT = DSelfZZT + (e**2*Pi**(-2)/576)*sw**2
     & *cw**(-2) * (
     &     + 2
     &     + 3*B0(MMZ,MMW,MMW)
     &     + 60*DB0(MMZ,MMW,MMW)*MW**2
     &     + 3*DB0(MMZ,MMW,MMW)*MZ**2
     &     )
      DSelfZZT = DSelfZZT + (e**2*Pi**(-2)/576) * (
     &     - 4
     &     - 48*GVLN2
     &     - 48*GALN2
     &     - 48*GVLL2
     &     - 48*GALL2
     &     - 144*GVQU2
     &     - 144*GAQU2
     &     - 144*GVQD2
     &     - 144*GAQD2
     &     - 6*B0(MMZ,MMW,MMW)
     &     + 24*DB0(MMZ,MMW,MMW)*MW**2
     &     - 6*DB0(MMZ,MMW,MMW)*MZ**2
     &     )

      do i1=1,3
      SelfZZT = SelfZZT + (e**2*Pi**(-2)/576) * (
     &     - 96*A0(MLN2(i1))*GVLN2
     &     - 96*A0(MLN2(i1))*GALN2
     &     - 96*A0(MLL2(i1))*GVLL2
     &     - 96*A0(MLL2(i1))*GALL2
     &     - 288*A0(MQU2(i1))*GVQU2
     &     - 288*A0(MQU2(i1))*GAQU2
     &     - 288*A0(MQD2(i1))*GVQD2
     &     - 288*A0(MQD2(i1))*GAQD2
     &     + 48*B0(MMZ,MLN2(i1),MLN2(i1))*MZ**2*GVLN2
     &     + 48*B0(MMZ,MLN2(i1),MLN2(i1))*MZ**2*GALN2
     &     + 96*B0(MMZ,MLN2(i1),MLN2(i1))*MLN2(i1)*GVLN2
     &     - 192*B0(MMZ,MLN2(i1),MLN2(i1))*MLN2(i1)*GALN2
     &     + 48*B0(MMZ,MLL2(i1),MLL2(i1))*MZ**2*GVLL2
     &     + 48*B0(MMZ,MLL2(i1),MLL2(i1))*MZ**2*GALL2
     &     + 96*B0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*GVLL2
     &     - 192*B0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*GALL2
     &     + 144*B0(MMZ,MQU2(i1),MQU2(i1))*MZ**2*GVQU2
     &     + 144*B0(MMZ,MQU2(i1),MQU2(i1))*MZ**2*GAQU2
     &     + 288*B0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*GVQU2
     &     - 576*B0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*GAQU2
     &     + 144*B0(MMZ,MQD2(i1),MQD2(i1))*MZ**2*GVQD2
     &     + 144*B0(MMZ,MQD2(i1),MQD2(i1))*MZ**2*GAQD2
     &     + 288*B0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*GVQD2
     &     - 576*B0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*GAQD2
     &     + 96*MLN2(i1)*GVLN2
     &     + 96*MLN2(i1)*GALN2
     &     + 96*MLL2(i1)*GVLL2
     &     + 96*MLL2(i1)*GALL2
     &     + 288*MQU2(i1)*GVQU2
     &     + 288*MQU2(i1)*GAQU2
     &     + 288*MQD2(i1)*GVQD2
     &     + 288*MQD2(i1)*GAQD2
     &     )

      DSelfZZT = DSelfZZT + (e**2*Pi**(-2)/576) * (
     &     + 48*B0(MMZ,MLN2(i1),MLN2(i1))*GVLN2
     &     + 48*B0(MMZ,MLN2(i1),MLN2(i1))*GALN2
     &     + 48*B0(MMZ,MLL2(i1),MLL2(i1))*GVLL2
     &     + 48*B0(MMZ,MLL2(i1),MLL2(i1))*GALL2
     &     + 144*B0(MMZ,MQU2(i1),MQU2(i1))*GVQU2
     &     + 144*B0(MMZ,MQU2(i1),MQU2(i1))*GAQU2
     &     + 144*B0(MMZ,MQD2(i1),MQD2(i1))*GVQD2
     &     + 144*B0(MMZ,MQD2(i1),MQD2(i1))*GAQD2
     &     + 48*DB0(MMZ,MLN2(i1),MLN2(i1))*MZ**2*GVLN2
     &     + 48*DB0(MMZ,MLN2(i1),MLN2(i1))*MZ**2*GALN2
     &     + 96*DB0(MMZ,MLN2(i1),MLN2(i1))*MLN2(i1)*GVLN2
     &     - 192*DB0(MMZ,MLN2(i1),MLN2(i1))*MLN2(i1)*GALN2
     &     + 48*DB0(MMZ,MLL2(i1),MLL2(i1))*MZ**2*GVLL2
     &     + 48*DB0(MMZ,MLL2(i1),MLL2(i1))*MZ**2*GALL2
     &     + 96*DB0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*GVLL2
     &     - 192*DB0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*GALL2
     &     + 144*DB0(MMZ,MQU2(i1),MQU2(i1))*MZ**2*GVQU2
     &     + 144*DB0(MMZ,MQU2(i1),MQU2(i1))*MZ**2*GAQU2
     &     + 288*DB0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*GVQU2
     &     - 576*DB0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*GAQU2
     &     + 144*DB0(MMZ,MQD2(i1),MQD2(i1))*MZ**2*GVQD2
     &     + 144*DB0(MMZ,MQD2(i1),MQD2(i1))*MZ**2*GAQD2
     &     + 288*DB0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*GVQD2
     &     - 576*DB0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*GAQD2
     &     )
      enddo


      SelfH = + (e**2*Pi**(-2)/128)*sw**(-2)*cw**(-4) * (
     &     + 8*MW**2
     &     - 14*B0(MMH,MMZ,MMZ)*MW**2
     &     )
      SelfH = SelfH + (e**2*Pi**(-2)/128)*sw**(-2)*cw**(-2) * (
     &     + 4*MZ**2
     &     - 6*A0(MMZ)
     &     + 2*B0(MMH,MMZ,MMZ)*MZ**2
     &     + 4*B0(MMH,MMZ,MMZ)*MH**2
     &     )
      SelfH = SelfH + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &     + 24*MW**2
     &     - 12*A0(MMW)
     &     - 2*A0(MMW)*MW**(-2)*MH**2
     &     - A0(MMZ)*MW**(-2)*MH**2
     &     - 3*A0(MMH)*MW**(-2)*MH**2
     &     - 2*B0(MMH,MMW,MMW)*MW**(-2)*MH**4
     &     - 24*B0(MMH,MMW,MMW)*MW**2
     &     + 8*B0(MMH,MMW,MMW)*MH**2
     &     - B0(MMH,MMZ,MMZ)*MW**(-2)*MH**4
     &     - 9*B0(MMH,MMH,MMH)*MW**(-2)*MH**4
     &     )

      DSelfH = + (e**2*Pi**(-2)/128)*sw**(-2)*cw**(-4) * (
     &     - 14*DB0(MMH,MMZ,MMZ)*MW**2
     &     )
      DSelfH = DSelfH + (e**2*Pi**(-2)/128)*sw**(-2)*cw**(-2) * (
     &     + 4*B0(MMH,MMZ,MMZ)
     &     + 2*DB0(MMH,MMZ,MMZ)*MZ**2
     &     + 4*DB0(MMH,MMZ,MMZ)*MH**2
     &     )
      DSelfH = DSelfH + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &     + 8*B0(MMH,MMW,MMW)
     &     - 2*DB0(MMH,MMW,MMW)*MW**(-2)*MH**4
     &     - 24*DB0(MMH,MMW,MMW)*MW**2
     &     + 8*DB0(MMH,MMW,MMW)*MH**2
     &     - DB0(MMH,MMZ,MMZ)*MW**(-2)*MH**4
     &     - 9*DB0(MMH,MMH,MMH)*MW**(-2)*MH**4
     &     )
      do i1=1,3
        SelfH = SelfH + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &       + 8*A0(MLL2(i1))*MLL2(i1)*MW**(-2)
     &       + 24*A0(MQU2(i1))*MQU2(i1)*MW**(-2)
     &       + 24*A0(MQD2(i1))*MQD2(i1)*MW**(-2)
     &       - 4*B0(MMH,MLL2(i1),MLL2(i1))*MLL2(i1)*MW**(-2)*MH**2
     &       + 16*B0(MMH,MLL2(i1),MLL2(i1))*MLL2(i1)**2*MW**(-2)
     &       - 12*B0(MMH,MQU2(i1),MQU2(i1))*MQU2(i1)*MW**(-2)*MH**2
     &       + 48*B0(MMH,MQU2(i1),MQU2(i1))*MQU2(i1)**2*MW**(-2)
     &       - 12*B0(MMH,MQD2(i1),MQD2(i1))*MQD2(i1)*MW**(-2)*MH**2
     &       + 48*B0(MMH,MQD2(i1),MQD2(i1))*MQD2(i1)**2*MW**(-2)
     &       )
        
        DSelfH = DSelfH + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &       - 4*B0(MMH,MLL2(i1),MLL2(i1))*MLL2(i1)*MW**(-2)
     &       - 12*B0(MMH,MQU2(i1),MQU2(i1))*MQU2(i1)*MW**(-2)
     &       - 12*B0(MMH,MQD2(i1),MQD2(i1))*MQD2(i1)*MW**(-2)
     &       - 4*DB0(MMH,MLL2(i1),MLL2(i1))*MLL2(i1)*MW**(-2)*MH**2
     &       + 16*DB0(MMH,MLL2(i1),MLL2(i1))*MLL2(i1)**2*MW**(-2)
     &       - 12*DB0(MMH,MQU2(i1),MQU2(i1))*MQU2(i1)*MW**(-2)*MH**2
     &       + 48*DB0(MMH,MQU2(i1),MQU2(i1))*MQU2(i1)**2*MW**(-2)
     &       - 12*DB0(MMH,MQD2(i1),MQD2(i1))*MQD2(i1)*MW**(-2)*MH**2
     &       + 48*DB0(MMH,MQD2(i1),MQD2(i1))*MQD2(i1)**2*MW**(-2)
     &       )
      enddo

      SelfG0 = + (e**2*Pi**(-2)/128)*sw**(-2)*cw**(-2) * (
     &     + 4*MZ**2
     &     - 4*A0(MMZ)
     &     - 2*A0(MMH)
     &     + 2*B0(MMZ,MMZ,MMH)*MZ**2
     &     + 4*B0(MMZ,MMZ,MMH)*MH**2
     &     )
      SelfG0 = SelfG0 + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &     + 8*MW**2
     &     - 12*A0(MMW)
     &     - 2*A0(MMW)*MW**(-2)*MH**2
     &     - 3*A0(MMZ)*MW**(-2)*MH**2
     &     - A0(MMH)*MW**(-2)*MH**2
     &     + 8*B0(MMZ,MMW,MMW)*MZ**2
     &     - 2*B0(MMZ,MMZ,MMH)*MW**(-2)*MH**4
     &     )

      DSelfG0 = + (e**2*Pi**(-2)/128)*sw**(-2) *cw**(-2) * (
     &     + 4*B0(MMZ,MMZ,MMH)
     &     + 2*DB0(MMZ,MMZ,MMH)*MZ**2
     &     + 4*DB0(MMZ,MMZ,MMH)*MH**2
     &     )
      DSelfG0 = DSelfG0 + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &     + 8*B0(MMZ,MMW,MMW)
     &     + 8*DB0(MMZ,MMW,MMW)*MZ**2
     &     - 2*DB0(MMZ,MMZ,MMH)*MW**(-2)*MH**4
     &     )

      do i1=1,3
        SelfG0 = SelfG0 + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &       + 8*A0(MLL2(i1))*MLL2(i1)*MW**(-2)
     &       + 24*A0(MQU2(i1))*MQU2(i1)*MW**(-2)
     &       + 24*A0(MQD2(i1))*MQD2(i1)*MW**(-2)
     &       - 4*B0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*MW**(-2)*MZ**2
     &       - 12*B0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*MW**(-2)*MZ**2
     &       - 12*B0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*MW**(-2)*MZ**2
     &       )
        
        DSelfG0 = DSelfG0 + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &       - 4*B0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*MW**(-2)
     &       - 12*B0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*MW**(-2)
     &       - 12*B0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*MW**(-2)
     &       - 4*DB0(MMZ,MLL2(i1),MLL2(i1))*MLL2(i1)*MW**(-2)*MZ**2
     &       - 12*DB0(MMZ,MQU2(i1),MQU2(i1))*MQU2(i1)*MW**(-2)*MZ**2
     &       - 12*DB0(MMZ,MQD2(i1),MQD2(i1))*MQD2(i1)*MW**(-2)*MZ**2
     &       )
      enddo

      SelfGW = + (e**2*Pi**(-2)/128)*sw**(-2)*cw**2 * (
     &     + 4*MZ**2
     &     - 2*A0(MMW)
     &     - 4*A0(MMZ)
     &     + 8*B0(MMW,MMW,MMZ)*MW**2
     &     - 2*B0(MMW,MMW,MMZ)*MZ**2
     &     )
      SelfGW = SelfGW + (e**2*Pi**(-2)/128)*sw**2*cw**(-2) * (
     &     + 16*MW**2
     &     + 4*MZ**2
     &     - 2*A0(MMW)
     &     - 4*A0(MMZ)
     &     - 24*B0(MMW,MMW,MMZ)*MW**2
     &     - 2*B0(MMW,MMW,MMZ)*MZ**2
     &     )
      SelfGW = SelfGW + (e**2*Pi**(-2)/128)*cw**(-2) * (
     &     + 4*B0(MMW,MMW,MMZ)*MW**2
     &     )
      SelfGW = SelfGW + (e**2*Pi**(-2)/128) * (
     &     + 16*MW**2
     &     - 8*MZ**2
     &     - 16*A0(MMA)
     &     - 4*A0(MMW)
     &     + 8*A0(MMZ)
     &     - 16*B0(MMW,MMW,MMZ)*MW**2
     &     + 4*B0(MMW,MMW,MMZ)*MZ**2
     &     )
      SelfGW = SelfGW + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &     + 8*MW**2
     &     - 8*A0(MMW)
     &     - 4*A0(MMW)*MW**(-2)*MH**2
     &     - 2*A0(MMZ)
     &     - A0(MMZ)*MW**(-2)*MH**2
     &     - 2*A0(MMH)
     &     - A0(MMH)*MW**(-2)*MH**2
     &     - 2*B0(MMW,MMW,MMZ)*MW**2
     &     + 4*B0(MMW,MMW,MMZ)*MZ**2
     &     - 2*B0(MMW,MMW,MMH)*MW**(-2)*MH**4
     &     + 2*B0(MMW,MMW,MMH)*MW**2
     &     + 4*B0(MMW,MMW,MMH)*MH**2
     &     )

      DSelfGW = + (e**2*Pi**(-2)/128)*sw**(-2)*cw**2 * (
     &     + 4*B0(MMW,MMW,MMZ)
     &     + 8*DB0(MMW,MMW,MMZ)*MW**2
     &     - 2*DB0(MMW,MMW,MMZ)*MZ**2
     &     )
      DSelfGW = DSelfGW + (e**2*Pi**(-2)/128)*sw**2*cw**(-2) * (
     &     + 4*B0(MMW,MMW,MMZ)
     &     - 24*DB0(MMW,MMW,MMZ)*MW**2
     &     - 2*DB0(MMW,MMW,MMZ)*MZ**2
     &     )
      DSelfGW = DSelfGW + (e**2*Pi**(-2)/128)*cw**(-2) * (
     &     + 4*DB0(MMW,MMW,MMZ)*MW**2
     &     )
      DSelfGW = DSelfGW + (e**2*Pi**(-2)/128) * (
     &     + 16*B0(MMW,MMA,MMW)
     &     - 8*B0(MMW,MMW,MMZ)
     &     - 16*DB0(MMW,MMW,MMZ)*MW**2
     &     + 4*DB0(MMW,MMW,MMZ)*MZ**2
     &     )
      DSelfGW = DSelfGW + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &     + 4*B0(MMW,MMW,MMZ)
     &     + 4*B0(MMW,MMW,MMH)
     &     - 2*DB0(MMW,MMW,MMZ)*MW**2
     &     + 4*DB0(MMW,MMW,MMZ)*MZ**2
     &     - 2*DB0(MMW,MMW,MMH)*MW**(-2)*MH**4
     &     + 2*DB0(MMW,MMW,MMH)*MW**2
     &     + 4*DB0(MMW,MMW,MMH)*MH**2
     &     )
      do i1=1,3
        SelfGW = SelfGW + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &       + 4*A0(MLN2(i1))*MLL2(i1)*MW**(-2)
     &       + 4*A0(MLL2(i1))*MLL2(i1)*MW**(-2)
     &       + 4*B0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)*MLL2(i1)*MW**(-2)
     &       - 4*B0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)
     &       + 4*B0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)**2*MW**(-2)
     &       )
        DSelfGW = DSelfGW + (e**2*Pi**(-2)/128)*sw**(-2) * (
     &       - 4*B0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)*MW**(-2)
     &       + 4*DB0(MMW,MLL2(i1),MLN2(i1))*MLN2(i1)*MLL2(i1)*MW**(-2)
     &       - 4*DB0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)
     &       + 4*DB0(MMW,MLL2(i1),MLN2(i1))*MLL2(i1)**2*MW**(-2)
     &       )
        do i2=1,3
          SelfGW = SelfGW + CKM(i1,i2)*CKMD(i1,i2)*(e**2*
     &         Pi**(-2)/128)*sw**(-2) * (
     &         + 12*A0(MQU2(i1))*MQU2(i1)*MW**(-2)
     &         + 12*A0(MQU2(i1))*MQD2(i2)*MW**(-2)
     &         + 12*A0(MQD2(i2))*MQU2(i1)*MW**(-2)
     &         + 12*A0(MQD2(i2))*MQD2(i2)*MW**(-2)
     &         - 12*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)
     &         + 12*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)**2*MW**(-2)
     &         - 24*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)*MQD2(i2)*MW**(-2)
     &         - 12*B0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)
     &         + 12*B0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)**2*MW**(-2)
     &         )
          DSelfGW = DSelfGW + CKM(i1,i2)*CKMD(i1,i2)*(e**2
     &         *Pi**(-2)/128)*sw**(-2) * (
     &         - 12*B0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)*MW**(-2)
     &         - 12*B0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)*MW**(-2)
     &         -12*DB0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)
     &         +12*DB0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)**2*MW**(-2)
     &         -24*DB0(MMW,MQU2(i1),MQD2(i2))*MQU2(i1)*MQD2(i2)*MW**(-2)
     &         -12*DB0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)
     &         +12*DB0(MMW,MQU2(i1),MQD2(i2))*MQD2(i2)**2*MW**(-2)
     &         )
        enddo
      enddo

      Tadpole = + (e*Pi**(-2)/64)*sw**(-1)*cw**(-2) * (
     &     - 4*MW*MZ**2
     &     + 6*A0(MMZ)*MW
     &     )
      Tadpole = Tadpole + (e*Pi**(-2)/64)*sw**(-1) * (
     &     - 8*MW**3
     &     + 2*A0(MMW)*MW**(-1)*MH**2
     &     + 12*A0(MMW)*MW
     &     + A0(MMZ)*MW**(-1)*MH**2
     &     + 3*A0(MMH)*MW**(-1)*MH**2
     &     )
      do i1=1,3
      Tadpole = Tadpole + (e*Pi**(-2)/64)*sw**(-1) * (
     &     - 8*A0(MLL2(i1))*MLL2(i1)*MW**(-1)
     &     - 24*A0(MQU2(i1))*MQU2(i1)*MW**(-1)
     &     - 24*A0(MQD2(i1))*MQD2(i1)*MW**(-1)
     &       )
      enddo
C -----------------------------------------------------------------------
C Eqs (3.19)
C Tadpole

        dtad=-Tadpole

        dMMW= DBLE(SelfWT)
        dMMZ= DBLE(SelfZZT)
C Convention of SigmaH is oppossite sign to VV, but I compute them
C equally in the 
        dMMH=-DBLE(SelfH)

        dZAA=-DBLE(DSelfAAT)
        dZAZ=-2*DBLE(SelfAZT)/MZ**2
        dZZA=+2*DBLE(SelfZAT)/MZ**2
        dZZZ=-DBLE(DSelfZZT)
C Again different sign than in paper
        dZH =+DBLE(DSelfH)
        dZG0=+DBLE(DSelfG0)
        dZGW=+DBLE(DSelfGW)

C Eq (3.35)
        dsw = -cw**2/(2*sw)*DBLE(dMMW/MMW-dMMZ/MMZ)

C Eq (3.32)
        dZe = 0.5D0*DBLE(-dZAA-dZZA*sw/cw)



#ifdef DEBUG
      do i1=1,4
        do i2=1,3
          print 11,' dMf(',i1,',',i2,')=', dMf(i1,i2)
          print 11,'dZfV(',i1,',',i2,')=', dZfV(i1,i2)
          print 11,'dZfA(',i1,',',i2,')=', dZfA(i1,i2)
        enddo
      enddo
 11   format (A5,I1,A1,I1,A2,1X,E22.16)

      print *, 'Tadpole =', Tadpole
      print *, ' SelfWT =', SelfWT
      print *, 'DSelfWT =',DSelfWT
      print *, ' SelfAAT=', SelfAAT
      print *, 'DSelfAAT=',DSelfAAT
      print *, ' SelfAZT=', SelfAZT
      print *, ' SelfZAT=', SelfZAT
      print *, ' SelfZZT=', SelfZZT
      print *, 'DSelfZZT=',DSelfZZT
      print *, ' SelfH  =', SelfH
      print *, 'DSelfH  =',DSelfH
      print *, ' SelfG0 =', SelfG0
      print *, 'DSelfG0 =',DSelfG0
      print *, ' SelfGW =', SelfGW
      print *, 'DSelfGW =',DSelfGW

      print *, 'dMMW =', dMMW
      print *, 'dMMZ =', dMMZ
      print *, 'dMMH =', dMMH

      print *, 'dZAA =', dZAA
      print *, 'dZAZ =', dZAZ
      print *, 'dZZA =', dZZA
      print *, 'dZZZ =', dZZZ
      print *, 'dZH  =', dZH
      print *, 'dZG0 =', dZG0
      print *, 'dZGW =', dZGW

      print *, 'dsw  =', dsw
      print *, 'dtad =', dtad
      print *, 'dZe  =', dZe
    
#endif

 20   continue
      return
      end
